#line 1 "C:/Users/Corey/Documents/Projects/C_Meter/AVR/C_Meter_AVR.c"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for avr/include/stdbool.h"



 typedef char _Bool;
#line 5 "C:/Users/Corey/Documents/Projects/C_Meter/AVR/C_Meter_AVR.c"
sbit C_METER_RST at PORTA6_bit;
sbit C_METER_RST_DIR at DDA6_bit;
sbit C_METER_INT at PIND2_bit;
sbit C_METER_INT_DIR at DDD2_bit;

void system_setup( void );
void setup_interrupt( void );
void InitTimer1( void );

volatile  _Bool  flag;
volatile uint32_t start_val;
volatile uint32_t end_val;
char uart_text[ 40 ];
char final_text[ 40 ];
uint32_t int_count = 0;
uint32_t timer_count_end = 0;
 _Bool  sec_flag =  0 ;
volatile float c_cal = 0.0;
volatile float t_meas = 0.0;
volatile float c_meas = 0.0;
volatile float final = 0.0;
volatile float t_cal = 0.0;


void main()
{

  _Bool  calibration_flag =  1 ;


 system_setup();
 setup_interrupt();
 InitTimer1();

 t_cal = 1.0 / 22587.0;
 c_cal = t_cal / 77616.0;

 int_count = 0;

 while(1)
 {

 if( sec_flag )
 {

 sprintf( uart_text, "Interrupts : %u\r\n", timer_count_end );
 UART1_Write_Text( uart_text );

 t_meas = 1.0 / timer_count_end;
 c_meas = t_meas / 77616.0;
 final = fabs( c_cal - c_meas );

 UART1_Write_Text( "Calibrated: " );
 FloatToStr( c_cal, uart_text );
 UART1_Write_Text( uart_text );
 UART1_Write_Text( "\r\n" );
 UART1_Write_Text( "Final: " );
 FloatToStr( final, final_text );
 UART1_Write_Text( final_text );
 UART1_Write_Text( "\r\n" );

 sec_flag =  0 ;
 int_count = 0;
 timer_count_end = 0;
 }
 }
}

void system_setup( void )
{

 C_METER_INT_DIR = 0;
 C_METER_RST_DIR = 1;


 C_METER_RST = 0;
 Delay_ms(50);
 C_METER_RST = 1;


 UART1_Init( 9600 );
 UART1_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{
 GICR |= ( 1 << 6 );
 MCUCR |= 3;
 SREG |= ( 1 << 7 );
}

void interrupt() iv IVT_ADDR_INT0 ics ICS_AUTO
{
 int_count++;
}

void InitTimer1(){
 SREG_I_bit = 1;
 TCCR1A = 0x80;
 TCCR1B = 0x0C;
 OCR1AH = 0x7A;
 OCR1AL = 0x11;
 OCIE1A_bit = 1;
}

void Timer1Overflow_ISR() org IVT_ADDR_TIMER1_COMPA {

 timer_count_end = int_count;
 int_count = 0;
 sec_flag =  1 ;
}
